<?php
/**
 * GGF function - Edior page functions
 * @param $form
 */
function ggf_gmw_custom_fields($form){
	global $ggfOptions;
	
	if ( isset($form['ggf_settings']) ) $ggfOptions = $form['ggf_settings'];
	
	if ( !isset($ggfOptions['address_fields']['use']) || $ggfOptions['address_fields']['use'] == 0 ) return $form;
	
	/**
	 * GGF function - add buttons to form editor
	 */
	function ggf_add_field_groups( $field_groups ) {
		global $ggfOptions;
		
		//add ggf fields button
		$ggf_fields[] = array("class"=>"button ggf-fields-button", "value" => __("GEO Field", "GGF"), "onclick" => "StartAddField('post_custom_field');");
		//only if single address field add the map button
		if ( $ggfOptions['address_fields']['use'] == 1 ) $ggf_fields[] = array("class"=>"button ggf-map-button", "value" => __("GGF Map", "GGF"),"onclick" => "StartAddField('ggfMap');");
		//create ggf buttons section
		$field_groups[] = array("name" => "ggf_fields", "label"=> __("GEO Fields", "GGF"), "fields" => apply_filters('ggf_field_buttons', $ggf_fields, $field_groups));
	
		return $field_groups;
	}
	add_filter("gform_add_field_buttons", 'ggf_add_field_groups', 10, 1);
	
	/*
	 * Change title name for fields
	*/
	function ggf_field_type_title( $type ) {
	
		if ( $type == 'mapIcons' )
			return __( 'GGF map icons' , 'GGF' );
		if ( $type == 'ggfMap' )
			return __( 'GGF Map' , 'GGF' );
	}
	add_filter( 'gform_field_type_title' , 'ggf_field_type_title', 10, 1 );
	 
	/**
	 * GGF function - Add ggf fields to the input fields
	 */
	function ggf_settings( $position, $form_id ) {
	
		if( $position == 50 ){
	
			$form = RGFormsModel::get_form_meta_by_id($form_id);
			$gffSettings = $form[0]['ggf_settings'];
	
			?>
			<!-- 
			<li class="ggf-autocomplete-settings field_setting">
				<label for="ggf-autocomplete-field">
					<?php _e("Custom Field", "GGF"); ?>
					<?php gform_tooltip("ggf_acfield_tt"); ?>
				</label>
				<input type="text" id="field-ggf-autocomplete-field" class="" size="15" onkeyup="SetFieldProperty('ggf-autocomplete-field', this.value);">
			</li>
			-->
			
			<li class="ggf-map-width field_setting ggf-map-settings ">
		
				<label for="ggf-map-width">
					<?php _e("Map Width", "GGF"); ?>
					<?php gform_tooltip("ggf_width_tt"); ?>
				</label>
				<input type="text" id="field-ggf-map-width" class="" size="15" onkeyup="SetFieldProperty('ggf-map-width', this.value);">
			
			</li>
			<li class="ggf-map-height field_setting ggf-map-settings ">
				<label for="ggf-map-height">
					<?php _e("Map Height", "GGF"); ?>
					<?php gform_tooltip("ggf_height_tt"); ?>
				</label>
				<input type="text" id="field-ggf-map-height" class="" size="15" onkeyup="SetFieldProperty('ggf-map-height', this.value);">
			</li>
			<li class="ggf-map-latitude field_setting ggf-map-settings ">
				<label for="ggf-map-latitude">
					<?php _e("Latitude", "GGF"); ?>
					<?php gform_tooltip("ggf_lat_tt"); ?>
				</label>
				<input type="text" id="field-ggf-map-latitude" class="" size="25" onkeyup="SetFieldProperty('ggf-map-latitude', this.value);">
			</li>
			<li class="ggf-map-longitude field_setting ggf-map-settings ">
				<label for="ggf-map-longitude">
					<?php _e("longitude", "GGF"); ?>
					<?php gform_tooltip("ggf_long_tt"); ?>
				</label>
				<input type="text" id="field-ggf-map-longitude" class="" size="25" onkeyup="SetFieldProperty('ggf-map-longitude', this.value);">
			</li>
			
			<li class="post_custom_field_type_setting field_setting" style="display: list-item;">
	        	<label for="post_custom_field_type">
	            	<?php _e('GEO fields - address field type','GGF'); ?><a href="#" class="tooltip tooltip_form_field_type" tooltip="&lt;h6&gt;Field type&lt;/h6&gt;Select the type of field from the available form fieldse">(?)</a>
	           	</label>
	           	<select name="ggf_fields" id="ggf-additional-fields" onchange="SetFieldProperty('ggf_fields', jQuery(this).val());">
	            	<option value=""><?php _e('N/A','GGF'); ?></option>
	            	<?php if ( $gffSettings['address_fields']['use'] == 1 ) : ?>
	            		<option value="address"><?php _e('Full Address','GGF'); ?></option>
	                <?php elseif ( $gffSettings['address_fields']['use'] == 2 ) : ?>
		                <option value="street"><?php _e('Street','GGF'); ?></option>
		                <option value="apt"><?php _e('Apt','GGF'); ?></option>
		                <option value="city"><?php _e('City','GGF'); ?></option>
		                <option value="state"><?php _e('State','GGF'); ?></option>
		                <option value="zipcode"><?php _e('Zipcode','GGF'); ?></option>
		                <option value="country"><?php _e('Country','GGF'); ?></option>
		            <?php endif; ?>
	                <?php if ( function_exists('gmw_loaded') ) : ?>
	                	<option value="phone"><?php _e('Phone Number','GGF'); ?></option>
	                	<option value="fax"><?php _e('Fax number','GGF'); ?></option>
	                	<option value="email"><?php _e('Email Address','GGF'); ?></option>
	                	<option value="website"><?php _e('Website','GGF'); ?></option>
	                <?php endif; ?>
	        	 </select>
	       	</li>
	       	<li class="post_custom_field_type_setting field_setting" style="display: list-item;">
	       		<input type="checkbox" id="field-ggf-autocomplete" onclick="SetFieldProperty('ggf-autocomplete', this.checked);" />
	            <label for="field_address_hide_state_<?php echo $key; ?>" class="inline">
	            	<?php _e("Autocomplete", "GGF"); ?>
	            	<?php gform_tooltip("ggf_autocomplete_tt"); ?>
	            </label>
	       </li>
		<?php
		}//get form details
	}
	add_action( "gform_field_standard_settings" , "ggf_settings" , 10, 2 );
	
	/**
	 * GFF buttons tooltips
	 */
	function ggf_tooltips($tooltips){
		
		$tooltips["ggf_width_tt"]  		= __("<h6>Map Width</h6>Enter the map width in pixels or percentage.","GGF");
		$tooltips["ggf_height_tt"] 		= __("<h6>Map Height</h6>Enter the map height in pixels or percentage.","GGF");
		$tooltips["ggf_lat_tt"]    		= __("<h6>Latitude</h6>Enter the latitude of the initial point that will be displayed on the map.","GGF");
		$tooltips["ggf_long_tt"]   		= __("<h6>Longitude</h6>Enter the longitude of the initial point that will be displayed on the map.","GGF");
		$tooltips["ggf_autocomplete_tt"] = __("<h6>Google's Autocomplete</h6>Add address autocomplete to the address field.","GGF");
		
		return $tooltips;
	}
	add_filter('gform_tooltips', 'ggf_tooltips');
	
	/**
	 * execute some javascript technicalitites for the field to load correctly
	 */
	function ggf_editor_js(){ ?>
	
		<script type='text/javascript'>
		
			jQuery(document).ready(function($) {
		
				$('#ggf-additional-fields').change(function() {
					if ( jQuery(this).val() == 'address' ) { 
						jQuery('#field-ggf-autocomplete').closest('li').show();
						jQuery('#field-ggf-autocomplete').removeAttr('disabled');
					} else { 
						jQuery('#field-ggf-autocomplete').closest('li').hide();
						jQuery('#field-ggf-autocomplete').attr('disabled','disabled');
					}
				});
	
				fieldSettings["mapIcons"] = ".label_setting, .description_setting, .admin_label_setting, .size_setting, .default_value_textarea_setting, .error_message_setting, .css_class_setting, .visibility_setting"; 
				fieldSettings["ggfMap"]   = ".ggf-map-settings , .label_setting, .description_setting, .admin_label_setting, .size_setting, .default_value_textarea_setting, .error_message_setting, .css_class_setting, .visibility_setting";
		
				jQuery(document).bind("gform_load_field_settings", function(event, field, form){
		
					//jQuery("#field-ggf-autocomplete-field").val(field["ggf-autocomplete-field"]);
	
					if ( field["ggf-autocomplete"] == true ) jQuery("#field-ggf-autocomplete").attr('checked','checked');
					jQuery("#field-ggf-map-width").val(field["ggf-map-width"]);
					jQuery("#field-ggf-map-height").val(field["ggf-map-height"]);
					jQuery("#field-ggf-map-latitude").val(field["ggf-map-latitude"]);
					jQuery("#field-ggf-map-longitude").val(field["ggf-map-longitude"]);
					jQuery("#ggf-additional-fields").val(field["ggf_fields"]);
	
					if ( jQuery("#ggf-additional-fields").val() == 'address' ) {
						jQuery('#field-ggf-autocomplete').closest('li').show();
						jQuery('#field-ggf-autocomplete').removeAttr('disabled');
					} else {
						jQuery('#field-ggf-autocomplete').closest('li').hide();
						jQuery('#field-ggf-autocomplete').attr('disabled','disabled');
					}
					
				});
			});
		
		</script>
	<?php }
	add_action( "gform_editor_js", "ggf_editor_js" );

	if ( !class_exists('GFUpdatePost') ) return $form;
	
	?>
	<script type="text/javascript">
		gform.addFilter("gform_pre_form_editor_save", "ggf_save_form");
	
		function ggf_save_form(form){

			var customFields = form.ggf_settings['address_fields']['fields'];
			var i;
			
			for ( i = 0; i < form.fields.length; i++ ) { 
				var field = form.fields[i];
					
				if ( field.ggf_fields == 'address' ) {
					if ( form.ggf_settings['address_fields']['update_post']['autocheck'] == 1 ) form.fields[i].postCustomFieldUnique = true;
					if ( customFields['address'] != '' ) {
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 1 ) form.fields[i].postCustomFieldName = customFields['address'];
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 2 ) form.fields[i].postCustomFieldName = '_wppl_address';
					}
				}
				
				if ( field.ggf_fields == 'street' ) {
					if ( form.ggf_settings['address_fields']['update_post']['autocheck'] == 1 ) form.fields[i].postCustomFieldUnique = true;
					if ( customFields['street'] != '' ) {
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 1 ) form.fields[i].postCustomFieldName = customFields['street'];
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 2 ) form.fields[i].postCustomFieldName = '_wppl_street';
					}
				} 
				if ( field.ggf_fields == 'apt' ) {
					if ( form.ggf_settings['address_fields']['update_post']['autocheck'] == 1 ) form.fields[i].postCustomFieldUnique = true;
					if ( customFields['apt'] != '' ) {
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 1 ) form.fields[i].postCustomFieldName = customFields['apt'];
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 2 ) form.fields[i].postCustomFieldName = '_wppl_apt';
					}
				} 
				if ( field.ggf_fields == 'city' ) {
					if ( form.ggf_settings['address_fields']['update_post']['autocheck'] == 1 ) form.fields[i].postCustomFieldUnique = true;
					if ( customFields['city'] != '' ) {
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 1 ) form.fields[i].postCustomFieldName = customFields['state'];
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 2 ) form.fields[i].postCustomFieldName = '_wppl_state';
					}
				} 
				if ( field.ggf_fields == 'state' ) {
					if ( form.ggf_settings['address_fields']['update_post']['autocheck'] == 1 ) form.fields[i].postCustomFieldUnique = true;
					if ( customFields['state'] != '' ) {
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 1 ) form.fields[i].postCustomFieldName = customFields['state'];
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 2 ) form.fields[i].postCustomFieldName = '_wppl_state';
					}
				}
				if ( field.ggf_fields == 'zipcode' ) {
					if ( form.ggf_settings['address_fields']['update_post']['autocheck'] == 1 ) form.fields[i].postCustomFieldUnique = true;
					if ( customFields['zipcode'] != '' ) {
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 1 ) form.fields[i].postCustomFieldName = customFields['zpicode'];
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 2 ) form.fields[i].postCustomFieldName = '_wppl_zipcode';
					}
				} 
				if ( field.ggf_fields == 'country' ) {
					if ( form.ggf_settings['address_fields']['update_post']['autocheck'] == 1 ) form.fields[i].postCustomFieldUnique = true;
					if ( customFields['country'] != '' ) {
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 1 ) form.fields[i].postCustomFieldName = customFields['country'];
						if ( form.ggf_settings['address_fields']['update_post']['use'] == 2 ) form.fields[i].postCustomFieldName = '_wppl_country';
					}
				}
			}
					
			return form;
		}
	</script>
	<?php
	//return the form object from the php hook	
	return $form;
}
add_action("gform_admin_pre_render", "ggf_gmw_custom_fields");